##############################################################################
#
# Copyright (c) 2001, 2002 Zope Corporation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
"""$Id: __init__.py,v 1.2 2002/12/16 21:12:52 longsleep Exp $
"""

# html rendered OpenOffice Documents for CMF/Plone by Simon Eisenmann

import OODocument
from Products.CMFCore.utils import ContentInit
from Products.CMFCore.DirectoryView import registerDirectory

# Define permission
ADD_CONTENT_PERMISSION = 'Add portal content'

# This is used by a script (external method) that can be run
# to install this product into a cmf instance
oodocument_globals  =globals()

# Make the skins available as DirectoryViews
registerDirectory( 'skins', globals() )
registerDirectory( 'skins/OODocument', globals() )

def initialize( context ):

    # CMF Initializers
    ContentInit( 'CMF OODocument Objects'
               , content_types = (OODocument.OODocument,)
               , permission = ADD_CONTENT_PERMISSION
               , extra_constructors = (OODocument.addOODocument,)
               , fti = OODocument.factory_type_information
               ).initialize( context )


